#!/bin/sh

CWD=$(dirname $0)

source $CWD/../static.conf

ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
NEW_CHANNEL_2G=$1
NEW_CHANNELBW_2G=$2

##############################################################
###TODO:# tested on 4.50.20.3 (date: 10.03.2019)
##############################################################
# - tests after disable wifi if same problem like CH6640E
# - Rekeying and keychange not used yet --> what are they???
#(- more stable version of extracting token in cookie)
##############################################################
###Note:#
# - changing channel take a certain amount of time
# - changing multiple times within a short time not tested yet
# - bash and sh have different function sets
##############################################################


# WiFi parameters
wlBandMode2g=""
wlBandMode5g=""
wlSsid2g=""
wlSsid5g=""
wlBandWidth2g=""
wlBandWidth5g=""
wlTxMode2g=""
wlTxMode5g=""
wlMCastRate2g=""
wlMCastRate5g=""
wlHiden2g=""
wlHiden5g=""
wlCoexistence=""
wlPSkey2g=""
wlPSkey5g=""
wlTxrate2g=""
wlTxrate5g=""
wlRekey2g=""
wlRekey5g=""
wlChannel2g=""
wlChannel5g=""
wlSecurity2g=""
wlSecurity5g=""
wlWpaalg26=""
wlWpaalg5g=""
wlkeychange2g=""
wlkeychange5g=""


check_arguments(){
    if [ -z "$NEW_CHANNEL_2G" ]; then
        echo "Channel argument is missing"
        exit 1
    elif [ -n "$NEW_CHANNELBW_2G" ]; then
        if [ "$NEW_CHANNELBW_2G" -eq 20 ]; then
            bandWidth2G=1
        elif [ "$NEW_CHANNELBW_2G" -eq 40 ]; then
            bandWidth2G=2
        else
            echo "Unsupported channel bandwidth given: $NEW_CHANNELBW_2G."
            exit 1
        fi
    else
        echo $bandWidth2G
    fi
    echo "NEW_CHANNEL: $NEW_CHANNEL_2G"
    echo "NEW_CHANNEL_BW: $NEW_CHANNELBW_2G"
}

get_token(){
	token=$(cat cookie.txt | grep sessionToken | awk '{print $7}')
	rm cookie.txt
}

login(){
	curl -s \
                -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
		-H "Host: $ROUTER_IP" \
		-H "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Upgrade-Insecure-Requests: 1" \
		-c "cookie.txt" \
		"http://$ROUTER_IP/" > /dev/null
	get_token
	login_data="token=$token&fun=15&Username=admin&Password=${ROUTER_PASSWORD}"
	login_resp=$(curl -s \
                -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
		-H "Host: $ROUTER_IP" \
		-H "Accept: text/plain, */*; q=0.01" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/common_page/login.html" \
		-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
		-c "cookie.txt" \
		-d "$login_data" \
		"http://$ROUTER_IP/xml/setter.xml") > /dev/null
	get_token
	#echo $login_resp
}

logout2(){
    data="token=$token&fun=16"
    curl -s \
        -H "Host: $ROUTER_IP" \
        -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
        -H "Accept: text/plain, */*; q=0.01" \
        -H "Accept-Language: en-US,en;q=0.5" \
        -H "Accept-Encoding: gzip, deflate" \
        -H "Referer: http://$ROUTER_IP/index.html" \
        -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
        -H "X-Requested-With: XMLHttpRequest" \
        -H "DNT: 1" \
        -H "Connection: keep-alive" \
        -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
        -d "$data" \
        -c "cookie.txt" \
        "http://$ROUTER_IP/xml/setter.xml" > /dev/null
    get_token
}

get_wifiInfo(){
	data="token=$token&fun=300"
	wifiInfo_resp=$(curl -s \
                -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
		-H "Host: $ROUTER_IP" \
		-H "Accept: application/xml, text/xml, */*; q=0.01" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/wifi_page/wlanRadio.html" \
		-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
                -c "cookie.txt" \
		-d "$data" \
		"http://$ROUTER_IP/xml/getter.xml")
	get_token
	bandmode=$(echo $wifiInfo_resp | awk -F'<Bandmode>' '{print $2}' | awk -F'<' '{print $1}')
	bssEnable2g=$(echo $wifiInfo_resp | awk -F'<BssEnable2g>' '{print $2}' | awk -F'<' '{print $1}')
	ssid2G=$(echo $wifiInfo_resp | awk -F'<SSID2G>' '{print $2}' | awk -F'<' '{print $1}')
	hideNetwork2g=$(echo $wifiInfo_resp | awk -F'<HideNetwork2G>' '{print $2}' | awk -F'<' '{print $1}')
	bandWidth2G=$(echo $wifiInfo_resp | awk -F'<BandWidth2G>' '{print $2}' | awk -F'<' '{print $1}')
	bssCoexistence=$(echo $wifiInfo_resp | awk -F'<BssCoexistence>' '{print $2}' | awk -F'<' '{print $1}')
	transmissionRate2g=$(echo $wifiInfo_resp | awk -F'<TransmissionRate2g>' '{print $2}' | awk -F'<' '{print $1}')
	transmissionMode2g=$(echo $wifiInfo_resp | awk -F'<TransmissionMode2g>' '{print $2}' | awk -F'<' '{print $1}')
	securityMode2g=$(echo $wifiInfo_resp | awk -F'<SecurityMode2g>' '{print $2}' | awk -F'<' '{print $1}')
	multicastRate2G=$(echo $wifiInfo_resp | awk -F'<MulticastRate2G>' '{print $2}' | awk -F'<' '{print $1}')
	channelSetting2G=$(echo $wifiInfo_resp | awk -F'<ChannelSetting2G>' '{print $2}' | awk -F'<' '{print $1}')
	currentChannel2G=$(echo $wifiInfo_resp | awk -F'<CurrentChannel2G>' '{print $2}' | awk -F'<' '{print $1}')
	preSharedKey2g=$(echo $wifiInfo_resp | awk -F'<PreSharedKey2g>' '{print $2}' | awk -F'<' '{print $1}')
	groupRekeyInterval2g=$(echo $wifiInfo_resp | awk -F'<GroupRekeyInterval2g>' '{print $2}' | awk -F'<' '{print $1}')
	wpaAlgorith2G=$(echo $wifiInfo_resp | awk -F'<WpaAlgorithm2G>' '{print $2}' | awk -F'<' '{print $1}')
	bssEnable5g=$(echo $wifiInfo_resp | awk -F'<BssEnable5g>' '{print $2}' | awk -F'<' '{print $1}')
	ssid5G=$(echo $wifiInfo_resp | awk -F'<SSID5G>' '{print $2}' | awk -F'<' '{print $1}')
	hideNetwork5G=$(echo $wifiInfo_resp | awk -F'<HideNetwork5G>' '{print $2}' | awk -F'<' '{print $1}')
	bandWidth5G=$(echo $wifiInfo_resp | awk -F'<BandWidth5G>' '{print $2}' | awk -F'<' '{print $1}')
	transmissionRate5g=$(echo $wifiInfo_resp | awk -F'<TransmissionRate5g>' '{print $2}' | awk -F'<' '{print $1}')
	transmissionMode5g=$(echo $wifiInfo_resp | awk -F'<TransmissionMode5g>' '{print $2}' | awk -F'<' '{print $1}')
	securityMode5g=$(echo $wifiInfo_resp | awk -F'<SecurityMode5g>' '{print $2}' | awk -F'<' '{print $1}')
	multicastRate5G=$(echo $wifiInfo_resp | awk -F'<MultiCastRate5G>' '{print $2}' | awk -F'<' '{print $1}')
	channelSetting5G=$(echo $wifiInfo_resp | awk -F'<ChannelSetting5G>' '{print $2}' | awk -F'<' '{print $1}')
	currentChannel5G=$(echo $wifiInfo_resp | awk -F'<CurrentChannel5G>' '{print $2}' | awk -F'<' '{print $1}')
	preSharedKey5g=$(echo $wifiInfo_resp | awk -F'<PreSharedKey5g>' '{print $2}' | awk -F'<' '{print $1}')
	groupRekeyInterval5g=$(echo $wifiInfo_resp | awk -F'<GroupRekeyInterval5g>' '{print $2}' | awk -F'<' '{print $1}')
	wpaAlgorithm5g=$(echo $wifiInfo_resp | awk -F'<WpaAlgorithm5g>' '{print $2}' | awk -F'<' '{print $1}')
}

change_wifiChannel(){
	data="token=$token&fun=1"
	curl -s \
                -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
		-H "Host: $ROUTER_IP" \
		-H "Accept: application/xml, text/xml, */*; q=0.01" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/wifi_page/wlanRadio.html" \
		-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
		-c "cookie.txt" \
		-d "$data" \
		"http://$ROUTER_IP/xml/getter.xml" > /dev/null
	get_token
	data2="token=$token&fun=315&wlBandMode2g=1&wlBandMode5g=2&wlSsid2g=$ssid2G&wlSsid5g=$ssid5G&wlBandwidth2g=$bandWidth2G&wlBandwidth5g=$bandWidth5G&wlTxMode2g=$transmissionMode2g&wlTxMode5g=$transmissionMode5g&wlMCastRate2g=$multicastRate2G&wlMCastRate5g=$multicastRate5G&wlHiden2g=$hideNetwork2G&wlHiden5g=$hideNetwork5G&wlCoexistence=$bssCoexistence&wlPSkey2g=$preSharedKey2g&wlPSkey5g=$preSharedKey5g&wlTxrate2g=$transmissionRate2g&wlTxrate5g=$transmissionRate5g&wlRekey2g=$groupRekeyInterval2g&wlRekey5g=$groupRekeyInterval5g&wlChannel2g=$NEW_CHANNEL_2G&wlChannel5g=$currentChannel5G&wlSecurity2g=$securityMode2g&wlSecurity5g=$securityMode5g&wlWpaalg2g=$wpaAlgorithm2G&wlWpaalg5g=$wpaAlgorithm5G&wlkeychange2g=0&wlkeychange5g=0"
	curl -s \
                -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
		-H "Host: $ROUTER_IP" \
		-H "Accept: text/plain, */*; q=0.01" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/wifi_page/wlanRadio.html" \
		-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
		-c "cookie.txt" \
		-d "$data2" \
		"http://$ROUTER_IP/xml/setter.xml" > /dev/null
	get_token
        sleep 15
}

write_log(){
    get_wifiInfo
    echo "Change channel to $NEW_CHANNEL_2G." >> log.txt
    echo $currentChannel2G
    if [ "$currentChannel2G" -eq "$NEW_CHANNEL_2G" ]; then
        echo "Change channel was successful." >> log.txt
    else
        echo "Change channel FAILED! Current channel is still $currentChannel2G" >> log.txt
    fi
}

main(){
    login
    get_wifiInfo
    check_arguments
    change_wifiChannel
    #write_log
    logout2
}

main
