#!/bin/sh

CWD=$(dirname $0)
ROUTER_IP=$(sh "$CWD/../general/get_router_ip.sh")
OPT=$1
STATUS_JSON="data/Status.json"

# get device name and firmware version
get_status_info(){
        time1=$(date +%s%N | cut -b1-13)
        rand1=$(( RANDOM % 1001 ))
        time2=$(date +%s%N | cut -b1-13)
        rand2=$(( RANDOM % 1001 ))
        url="http://$ROUTER_IP/$STATUS_JSON?_time=$time2&_rand=$rand1&_time=$time2&_rand=$rand2"
        page_source=$(curl -s -m 5 $url)
        DEVICE_NAME=$(echo $page_source | awk -F'"varid":"device_name",' '{print $2}' | awk -F'"' '{print $4}')
        FIRMWARE_VERSION=$(echo $page_source | awk -F'"varid":"firmware_version",' '{print $2}' | awk -F'"' '{print $4}')
        if [ "$OPT" = "-m" ]; then
		echo $DEVICE_NAME
	elif [ "$OPT" = "-f" ]; then
        	echo $FIRMWARE_VERSION
	else
		echo $DEVICE_NAME
		echo $FIRMWARE_VERSION
	fi
}

get_status_info
