#!/bin/sh

NEW_CHANNEL=$1

CWD=$(dirname $0)
ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
source $CWD/../static.conf

if [ -z "$1" ]; then
        echo "No channel supplied"
        exit 1
fi

curl_req(){
        json_data='{"id": 1,"method": "login","params": ["root", "'"${ROUTER_PASSWORD}"'"]}'
        curl_data=$(curl -s -X POST "http://$ROUTER_IP/cgi-bin/luci/rpc/auth" --data "$json_data")
        erg=$(echo $curl_data | awk -F'"result":"' '{print $2}' | awk -F'"' '{print $1}')
        echo $erg
}

TOKEN=$(curl_req)

# Set new channel
link="http://$ROUTER_IP/cgi-bin/luci/rpc/uci?auth=$TOKEN"
res=$(curl -s -X POST "$link" --data '{"id": "1","method": "set","params": ["wireless", "radio1", "channel", '"$NEW_CHANNEL"']}')
echo $res

# Commit new channel change
res=$(curl -s -X POST "$link" --data '{"id": "1","method": "set","params": ["wireless"]}')
echo $res

# Apply
res=$(curl -s -X POST "$link" --data '{"id": "1","method": "apply","params": ["wireless"]}')
echo $res
